var c_t cf_t R_t Rf_t pi_t pif_t q_t cM_t cMf_t eta_t eps_t etaf_t epsf_t r_t rf_t
    dc_t dcf_t ps_t psf_t lam_t lamf_t ts_t tor_t torf_t
    pihh_t piff_t pihf_t pifh_t phh_t phf_t pfh_t pff_t
    l_t lf_t w_t wf_t mc_t mcf_t
    uip_t
    gcM_t gcMf_t dq_t;
  //hh: home in home
  //fh foreign in home
  //hf: home in foreign
  //ff: foreign in foreign
varexo se1 se1f se2 se2f se3 se3f euip;
varobs gcM_t gcMf_t R_t Rf_t pi_t pif_t q_t;
parameters sigma beta phi_h phi_f rho_r1 rho_r2 psi_c1 psi_c2 psi_pi1 psi_pi2
           eta theta alpha rho_m1 rho_m2  corr_m rho_eta1 rho_eta2  corr_eta omega
           rho_ps1 rho_ps2 corr_ps rho_uip 
            iota b nu1 nu2
            psi_q1 psi_q2;

beta=.99;
sigma=1/5;
omega=2;
eta=1;
theta=10;
alpha=.75;
nu1=.8; nu2=.8;
phi_h=.9;phi_f=1-phi_h;
rho_r1=0.85;psi_c1=0;psi_pi1=1.05;
rho_r2=0.85;psi_c2=0;psi_pi2=1.05;
rho_m1=.8; rho_m2=.8; corr_m=0.0;
rho_eta1=0.9; rho_eta2=0.9;corr_eta=0.0;
rho_ps1=.9; rho_ps2=.9; corr_ps=0;
rho_uip=.7; 
iota=0;
b=.7;
psi_q1=0;
psi_q2=0;
model(linear);
#kappa1=(1-nu1)*(1-beta*nu1)/nu1;
#kappa2=(1-nu2)*(1-beta*nu2)/nu2;
#gamma_q=2*phi_h*phi_f;
#ksi_homo=omega+1/sigma;
#ksi_heter=(omega+1/sigma)/(1+omega*theta);

//c_t+ps_t=c_t(+1)+rho_ps*ps_t-sigma*(R_t-pi_t(+1));
//cf_t+psf_t=cf_t(+1)+rho_ps*psf_t-sigma*(Rf_t-pif_t(+1));
lam_t-R_t=lam_t(+1)-pi_t(+1);
lamf_t-Rf_t=lamf_t(+1)-pif_t(+1);

(1+beta*b^2)*c_t-b*c_t(-1)-beta*b*c_t(+1)=-sigma*(1-beta*b)*(1-b)*lam_t+ps_t;
(1+beta*b^2)*cf_t-b*cf_t(-1)-beta*b*cf_t(+1)=-sigma*(1-beta*b)*(1-b)*lamf_t+psf_t;

//International financial market
-lam_t+lamf_t=q_t+uip_t; //complete market
//q_t(+1)-q_t=R_t 
//ts_t=0; //financial autarky

//Trade balance
#param1=(1-phi_h)/((1-phi_h)^2-phi_h^2);
// ts_t=cM_t-c_t -param1*q_t;
   ts_t=phi_h*((1-eta)*phh_t+c_t)+(1-phi_h)*(cf_t-q_t+(1-eta)*phf_t)-c_t;
//Term of trade
 // tor_t=q_t/(2*phi_h-1);
    tor_t=pfh_t-phh_t;
    //torf_t=tor_t;
   torf_t=pff_t-phf_t;

//c_t+sigma*ps_t-(cf_t+sigma*psf_t)=sigma*q_t;
r_t=R_t-pi_t(+1);
rf_t=Rf_t-pif_t(+1);
dc_t=c_t-c_t(-1);
dcf_t=cf_t-cf_t(-1);
gcM_t=cM_t-cM_t(-1);
gcMf_t=cMf_t-cMf_t(-1);
dq_t=q_t-q_t(-1);

//Phillips curve
//LCP
//pi_t -iota*pi_t(-1) =beta*pi_t(+1) -beta*iota*pi_t +kappa*ksi_heter*(phi_h*cM_t+phi_f*cMf_t)+kappa*gamma_q*q_t-eta_t;
//pif_t-iota*pif_t(-1)=beta*pif_t(+1)-beta*iota*pif_t+kappa*ksi_heter*(phi_f*cM_t+phi_h*cMf_t)-kappa*gamma_q*q_t-etaf_t;
//PCP;
//pih_t -iota*pih_t(-1) =beta*pih_t(+1) -beta*iota*pih_t +kappa*ksi_heter*(cM_t+phi_f*tor_t)-eta_t;
//piff_t-iota*piff_t(-1)=beta*piff_t(+1)-beta*iota*piff_t+kappa*ksi_heter*(cMf_t-phi_f*tor_t)-etaf_t;
//pi_t =pih_t+phi_f*(tor_t-tor_t(-1));
//pif_t=piff_t-phi_f*(tor_t-tor_t(-1));


//Pricing sector
#param_sc=1/(1+(omega+1-alpha)/alpha*theta);
(1+beta*iota)*pihh_t -iota*pihh_t(-1)=beta*pihh_t+kappa1*param_sc*(mc_t-phh_t);
(1+beta*iota)*pifh_t -iota*pifh_t(-1)=beta*pifh_t+kappa2*param_sc*(mcf_t+q_t-pfh_t);
(1+beta*iota)*pihf_t -iota*pihf_t(-1)=beta*pihf_t+kappa1*param_sc*(mc_t-q_t-phf_t);
(1+beta*iota)*piff_t -iota*piff_t(-1)=beta*piff_t+kappa2*param_sc*(mcf_t-pff_t);
pi_t=phi_h*pihh_t+(1-phi_h)*pifh_t;
pif_t=(1-phi_h)*pihf_t+phi_h*piff_t;

0=(1-phi_h)*pfh_t+phi_h*phh_t;
0=(1-phi_h)*phf_t+phi_h*pff_t;

pihh_t=phh_t-phh_t(-1)+pi_t;
//pifh_t=pfh_t-pfh_t(-1)+pi_t;
//pihf_t=phf_t-phf_t(-1)+pi_t;
piff_t=pff_t-pff_t(-1)+pi_t;

//Production function;
cM_t=eta_t+alpha*l_t;
cMf_t=etaf_t+alpha*lf_t;

//marginal cost
  mc_t=w_t+l_t-cM_t;
  mcf_t=wf_t+lf_t-cMf_t;

//labor supply
  lam_t+w_t=omega*l_t;
  lamf_t+wf_t=omega*lf_t;
  
cM_t=phi_h*c_t+phi_f*cf_t+2*eta*(1-phi_h)*phi_h/(2*phi_h-1)*q_t;
cMf_t=phi_h*cf_t+phi_f*c_t-2*eta*(1-phi_h)*phi_h/(2*phi_h-1)*q_t;

R_t=rho_r1*R_t(-1)+(1-rho_r1)*(psi_c1*c_t+psi_pi1*pi_t+psi_q1*dq_t)+eps_t;
Rf_t=rho_r2*Rf_t(-1)+(1-rho_r2)*(psi_c2*cf_t+psi_pi2*pif_t-psi_q2*dq_t)+epsf_t;

eta_t=rho_eta1*eta_t(-1)+se1+corr_eta*se1f;
etaf_t=rho_eta2*etaf_t(-1)+se1f+corr_eta*se1;

eps_t=rho_m1*eps_t(-1)+se2+corr_m*se2f;
epsf_t=rho_m2*epsf_t(-1)+se2f+corr_m*se2;

ps_t=rho_ps1*ps_t(-1)+se3+corr_ps*se3f;
psf_t=rho_ps2*psf_t(-1)+se3f+corr_ps*se3;

uip_t=rho_uip*uip_t(-1)+euip;
end;




estimated_params;
sigma,.3,0.05,3,beta_pdf,.3,.1,0,1;
//beta, normal_pdf,.99,.003,.96,1;
phi_h,.9,0.3,1, beta_pdf,.6,.2,0,1;
b,.3,0,1,beta_pdf,.5,.25,0,1;
eta,.5,0,20,gamma_pdf, 1.5,.5,0;
nu1,.75,0,1,beta_pdf,.7,.2,0,1;
nu2,.67,0,1,beta_pdf,.7,.2,0,1;
rho_r1,.63,0,1,beta_pdf,.6,.2;
rho_r2,.70,0,1,beta_pdf,.6,.2;
psi_c1,.01,0,1,normal_pdf,.3,.1,,1;
psi_c2,.13,0,1,normal_pdf,.3,.1,,1;
psi_q1,.00,-1,1,normal_pdf,.3,.1,,1;
psi_q2,.0,-1,1,normal_pdf,.3,.1,,1;
psi_pi1,1.2,1,5,gamma_pdf,1.5,.5;
psi_pi2,1.2,1,5,gamma_pdf,1.5,.5;
//alpha, beta_pdf,.8,.1;
//omega,normal_pdf,3,1,0.25,5;
//theta,normal_pdf,3,1,1,20;
rho_m1,.4,0,1,beta_pdf,.5,.2,0,1;
corr_m,.15,-1,1,normal_pdf,0,.4;
rho_m2,.4,0,1,normal_pdf,.5,.2;
rho_eta1,.9,0,1,beta_pdf,.6,.2,0,1;
rho_eta2,.9,0,1,beta_pdf,.6,.2,0,1;
corr_eta,.1,-1,1,normal_pdf,.2,.2;
rho_uip,.85,0,1,beta_pdf,.6,.2,0,1;
rho_ps1,.9,0,1,beta_pdf,.6,.2;
rho_ps2,.9,0,1,beta_pdf,.6,.2;
corr_ps,.01,-1,1,normal_pdf,0,.4;
stderr se1,.85,0.01,6,inv_gamma_pdf,.5,1;
stderr se1f,.5,.01,6,inv_gamma_pdf,.5,1;
stderr se2,.3,.01,6,inv_gamma_pdf,.5,1;
stderr se2f,.25,.01,6,inv_gamma_pdf,.5,1;
stderr euip,4,.01,6,inv_gamma_pdf,.5,1;
stderr se3,.7,0.01,6,inv_gamma_pdf,.5,1;
stderr se3f,.6,.01,6,inv_gamma_pdf,.5,1;
end;
options_.compute_mode=6;
//Below is about the Monte-Carlo Optimization, it helps the MH step
options_.Opt6Numb =100000; 
options_.Opt6Iter=10;
estimation(datafile=readdata_euus,first_obs=1,mh_nblocks=10,prefilter=1,mh_jscale=0.4,mh_replic=5000,mode_check,bayesian_irf,solve_algo=3);
shocks;
var se1; stderr 1;
var se2; stderr 1;
var se1f;stderr 1;
var se2f;stderr 1;
var eq_t;stderr 1;
var epref_t;stderr 1;
var epreff_t;stderr 1;
end;

stoch_simul(irf=0,periods=200,noprint, nograph) c_t cf_t q_t R_t Rf_t cM_t pi_t pif_t cMf_t;
hpq_t=q_t-hpf(q_t,1600);
y_t=cM_t;
hpy_t=y_t-hpf(y_t,1600);
disp(['The persistence of real exchange rate is ',num2str(corr(q_t(1:end-1),q_t(2:end))),'(',num2str(corr(hpq_t(1:end-1),hpq_t(2:end))),')']);
disp(['The std(q_t)/std(y_t)  is ',num2str(std(q_t)./std(y_t)),'(',num2str(std(hpq_t)./std(hpy_t)),')']);

